﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;

namespace MC_Launcher_v2.Business.Data
{
    public class FileHashEntry
    {
        #region PROPERTIES
        public string Name { get; private set; }
        public string Hash { get; private set; }
        #endregion

        #region CONSTRUCTORS
        public FileHashEntry(string name, string hash)
        {
            Name = name;
            Hash = hash;
        }
        public static FileHashEntry FromFile(string name, string path)
        {
            string hash = CreateMD5(path);
            return new FileHashEntry(name, hash);
        }
        #endregion

        #region METHODS
        private static string CreateMD5(string file)
        {
            MD5 algo = MD5.Create();

            byte[] hash = new byte[] { 0 };

            using (FileStream str = new FileStream(file, FileMode.Open, FileAccess.Read))
                hash = algo.ComputeHash(str);
            return string.Join("", hash.Select((x) => x.ToString("X2")).ToArray());
        }
        #endregion
    }
}
